/*
 ASCII táblázat
 
 Minden lehetséges formában kiírja a byte értékeket:  
 * nyers bináris értékként
 * ASCII kódolású decimális, hexadecimális, oktális és bináris értékekként
 
 Bővebben az ASCII táblázatról:
 http://hu.wikipedia.org/wiki/ASCII
 http://hu.wikisource.org/wiki/Seg%C3%ADts%C3%A9g:ASCII
 
 created 2006 by Nicholas Zambetti  <http://www.zambetti.com> 
 modified 9 Apr 2012 by Tom Igoe
 */

void setup() { 
  //Soros port megnyitása 9600 bit/másodperc sebességgel.
  Serial.begin(9600); 
  while (!Serial) {
    ; // addig várunk, amíg a soros port megnyílik (csak Leonardonál szükséges)
  }

  // port megnyitása után kiírjuk a fejlécet.
  Serial.println("ASCII Table ~ Character Map"); 
} 

// az első grafikus karakter a ‘!’, aminek decimális értéke 33.
int thisByte = 33; 
// ASCII karaktereket is megadhatunk két aposztróf között
// mivel a kódtáblázat alapján automatikusan számként képződnek le
// int thisByte = '!';  

void loop() { 

  Serial.write(thisByte); 
  // változtatás nélkül, vagyis binárisan nyomtatja ki a byte-ot
  // A soros monitor automatikusan ASCII-ként fogja értelmezni,
  // ezért a kiküldött 33 (100001) ‘!’-ként jelenik majd meg

  Serial.print(", dec: "); 
  Serial.print(thisByte);      
  // A byte decimális értékét ASCII-kódokkal nyomtatja ki (33, tehát két 
  // hármasnak megfelelő byte-ot küld).
  // Ez a Serial.print() és Serial.println() függvények alapbeállítása.
  // Meghívhatjuk Serial.print(thisByte, DEC);-ként is, az eredmény ugyanaz.

  Serial.print(", hex: "); 
  Serial.print(thisByte, HEX);     
  // A byte hexadecimális értékét ASCII-kódok soraként nyomtatja ki, 
  // 21, vagyis 2-esnek majd egy 1-esnek megfelelő byte-ot küld.

  Serial.print(", oct: "); 
  Serial.print(thisByte, OCT);     
  // fentieknek megfelelően csak oktális alapon (41)

  Serial.print(", bin: "); 
  Serial.println(thisByte, BIN);   
  // binárisan, vagyis kettes alapon (100001).
  // figyeljük meg, hogy az utolsó függvény Serial.println a „soremelés” 
  // vezérlőkaraktert is elküldi az adat után

  // az utolsó látszó vagy grafikus karakter a 126, ami a  '~'
  if(thisByte == 126) {     // egyenlőségnél is használhatjuk az ASCII-kódot
    // (thisByte == '~') {

    // ciklus, amint elérjük az utolsó karaktert, ismétlődik a végtelenségig
    while(true) { 
      continue; 
    } 
  } 
  // amíg nem érünk a végére, emeljük a sorszám értékét eggyel - így ugrunk a 
  // következő karakterre.
  thisByte++;  
}




